/***************************************************************************************
  *
  * vpcknt.h - Kernel Module Primary Header File
  *
  * Copyright (c)2003 Vito Plantamura. All Rights Reserved.
  *
***************************************************************************************/

#pragma once

//=============
// Structures.
//=============

// --> Device Extension Structure Definition. <--

typedef struct _DEVICE_EXTENSION 
{
	// Boolean that indicates whether the user mode service/application has created the file object.

	ULONG			WasCreated;
	FAST_MUTEX		WasCreatedFastMutex;

	// Boolean that indicates if we have to intercept NDIS Activities.

	ULONG			InterceptNDIS;

	// State informations about the NDIS Hook.

	PNT_PROTOCOL_LIST			NdisProtocolList;
	PNDISHOOK_HANDLER_STUB		NdisStubsList;
	DWORD						NdisStubsNum;

	// List of Open Adapters for which the client wants to be informed.

	OALIST_ITEM*				OaList;
	DWORD						OaListItems;
	NDIS_SPIN_LOCK				OaListSpinLock;

	// List of packets waiting to be retrieved.

	NEXT_PACKET*				PacketsBuff;
	DWORD						PacketsBuffMaxItems;

	DWORD						PacketsBuffStart /* first allocated; -1 => empty */, PacketsBuffEnd /* first free */;

	DWORD						PacketsLost;

	PKEVENT						PacketsReadyEvent;

	NDIS_SPIN_LOCK				PacketsBuffSpinLock;

	// Loopback trick stuff.

	DWORD		dwLtLoopbackAdapterIpAddress; // tipically: 0xA9FE1981; zero if lt is disabled.
	DWORD		dwLtTrickNatIpAddress; // tipically: 0xA9FE1980; zero if lt is disabled.

	// Other.

	NDIS_SPIN_LOCK				ReceiveWorkItemSpinLock;
	DWORD						ReceiveWorkItemIdCounter;

	NDIS_SPIN_LOCK				PacketSerialCounterSpinLock;
	DWORD						PacketSerialCounter;

} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

// --> Externs <--

extern PDEVICE_OBJECT		g_pDeviceObject;
